#!/usr/bin/perl

################################################
# Script Copyright 1999-2008 Lawrence Goetz    #
# http://www.lawrencegoetz.com/                #
# goetz@lawrencegoetz.com                      #
################################################

################################################
# Make your changes here!

# Set to the path for location libraries.
#use lib "";

use MIME::Lite;
# Later on in the file, you can make changes to your mail settings.
# Search for the string: 
# MIME::Lite->send

# Your mail program.
$MAILPROG="/usr/sbin/sendmail";

# Date program.
$DATE="/bin/date";

# Default Subject.
$SUBJECT_DEFAULT="Signature";

# Default Filename.
$FILENAME_DEFAULT="signature.png";

# Allowed referers. Set this to your sites name and IP. Include a list of various
# sites you which to allow access to the script.
@referers = ('www.com','0.0.0.0');
################################################

# Default value. Set to 1 if you want to allow anysite to use this script.
# Only do so for testing. Normally set this to 0 to prevent unauthorized use.
$allowed=0;

# Check the referer to see if it's on the list.
    if ($ENV{'HTTP_REFERER'}) {
        foreach $referer (@referers) {
            if ($ENV{'HTTP_REFERER'} =~ m|https?://([^/]*)$referer|i) {
        	$allowed=1;
	     	last;
            }
        }
    }

# It's not on the list, so give an error message.
    if($allowed==0) {
        print ("Content-type: text/html\n\n");
        print ("Access to this script is not allowed, sorry.");
        exit;
    }

use GD;

use CGI qw/:standard/;

# Uncomment, if your version of GD supports true color and you want true color images.
# GD::Image->trueColor(1);

# Image dimensions.
$width=param('width');
$height=param('height');

if($width==undef || $height==undef) {
	print ("Content-type: text/html\n\n");
	print ("Image size wrong: $width $height");
	die 'image size errr';
}

# Email to mail to
$mailto=param('mailto');

unless ($mailto =~ /^[\w.+-]+\@[\w.+-]+$/) {
	print ("Content-type: text/html\n\n");
	print 'The TO address is not valid.';
	die 'email address error';
}

# Email from
$email=param('email');

unless ($email =~ /^[\w.+-]+\@[\w.+-]+$/) {
	print ("Content-type: text/html\n\n");
	print 'The FROM address is not valid.';
	die 'email address error';
}

# Name from
$name=param('name');

# Filename for the image.
$filename=param('filename');
if($filename eq "") {
	$filename=$FILENAME_DEFAULT;
}

# The subject of the email.
$subject=param('subject');
if($subject eq "") {
	$subject=$SUBJECT_DEFAULT;
}

# Create the image.
$im = new GD::Image->new($width,$height) || die 'image error';


# allocate background color
$background = $im->colorAllocate(param('BR'),param('BG'),param('BB'));

# allocate pen color
$penColor = $im->colorAllocate(param('PR'),param('PG'),param('PB'));

# Get the points.
$_=param('signature');
$drawn=param('signature');
if($_==undef){
	print ("Content-type: text/html\n\n");
	print "Nothing is drawn. $drawn";
	die 'no drawing';
}

# Set binary mode.
binmode STDOUT;

# Make a temp image on disk.
# Get the date:
$filetimestamp=`$DATE '+%H:%M:%S'`;
chomp($filetimestamp);
$tempimage="/tmp/tempimage.$filetimestamp.$$";
open (image, ">$tempimage");
print image $im->png();
close image;


# Mail the image.

# Headers.
### Create the multipart container
my $msg = MIME::Lite->new(
        From    =>"$name <$email>",
        To      =>$mailto,
        Subject =>$subject,
		Type 	=>"multipart/mixed"
) or die "Error creating multipart container: $!\n";


### Add the text message part
$msg->attach (
	  	Type 	=> 'TEXT',
  		Data    =>  "Machine $ENV{'REMOTE_ADDR'} sent the following...\n\n"
) or die "Error adding the text message part: $!\n";

### Add the Signature file
$msg->attach(
        Type     => "image/png",
        Path     => "$tempimage",
        Filename => "$filename",
        Disposition => 'attachment'
);


### Send the message
# Choose how MIME:Lite will send a message.
#MIME::Lite->send('smtp', "mail.yourisp.com");
#MIME::Lite->send('sendmail', "$MAILPROG -t");
MIME::Lite->send("sendmail");
$msg->send;

# Remove the temporary image.
unlink $tempimage;


# Page to visit when done.
$done=param('done');

# Redirect to a page when done.
if($done ne ""){
	print "Location: $done\n\n";
}

else {
	print ("Content-type: text/html\n\n");
	print 'It appears that you have all the files setup in order to use Goetz\'s Signature Applet.<P> You should receive an email with a blank image. If so, all is perfect. <P>';
	print 'If you\'d like to order the full version, please fill out an <A HREF="http://www.lawrencegoetz.com/programs/signature/order.html">Order Form</A>';
}

gdImageDestroy(im);

exit;
